/*************************************************************************
    WINMAIN.C -  WinMain (entry point, initialization, and message loop)

***************************************************************************/

#include "windows.h"
#include "grp.h"

BOOL FAR PASCAL
GRPDlg (HWND          hDlg,
            unsigned message,
            WORD     wparam,
            DWORD    lparam
           );

void
OpenGroup (void
          );

void
CloseGroup (void
           );

BOOL
GetGroupMembers (void
                );

void
GetString (LPSTR lpstrString
          );

void
DeleteMembersLB (HANDLE hDlg
                );


OFSTRUCT lpofOpenBuff;
HANDLE   hFile;

char     strGroupTitle 		[257];
char     strGroupFile 		[257];
char     strGroupMember 	[257];
char     strGroupProgram	[257];
char     strGroupIcon	 	[257];
WORD     wTitleDisplacement;
WORD     wDataDisplacement;
WORD     wMembersDisplacement;
WORD     wMemberDisplacement;


/***************************************
**                                    **
**    WinMain                         **
**                                    **
***************************************/
int PASCAL
WinMain (HANDLE hInstance,
         HANDLE hPrevInstance,
         LPSTR lpszCmdLine,
         int nCmdShow
        )
{
FARPROC lpfnGRPDlg;

  if (!hPrevInstance)
  {
    lpfnGRPDlg = MakeProcInstance (GRPDlg, hInstance);
    DialogBox (hInstance, "GRP", NULL, lpfnGRPDlg);
    FreeProcInstance (lpfnGRPDlg);
  }

  return (0);
}




/***************************************
**                                    **
**    GRPDlg                          **
**                                    **
***************************************/
BOOL FAR PASCAL
GRPDlg (HWND     hDlg,
       unsigned message,
       WORD     wparam,
       DWORD    lparam
      )
{
char strReturnString [257],
     strGrpNum [10];

DWORD dwSelection;

int i,
    nGroupFileLen;

BOOL bGetGroupMember;

  switch (message)
  {
    case WM_INITDIALOG  :
      SetDlgItemText (hDlg, ID_PROGRAM, " ");
      SetDlgItemText (hDlg, ID_ICON, " ");

      i = 1;
      do
      {
        wsprintf (strGrpNum, "Group%d", i);
        nGroupFileLen = GetPrivateProfileString ("Groups",
                                                 strGrpNum,
                                                 "",
                                                 strGroupFile,
                                                 256,
                                                 "progman.ini"
                                                ); 
        i++;

        if (nGroupFileLen)
        {
          OpenGroup ();
          CloseGroup ();
          SendDlgItemMessage (hDlg,
                              ID_GROUP_TITLE,
                              LB_ADDSTRING,
                              0,
                              strGroupTitle
                             );
        }
      } while (nGroupFileLen);     
      return (TRUE);

    case WM_COMMAND     :
      switch (wparam)
      {
        case ID_GROUP_TITLE	:
          switch (HIWORD (lparam))
          {
            case LBN_SELCHANGE	:
              DeleteMembersLB (hDlg);

              SetDlgItemText (hDlg, ID_PROGRAM, " ");
              SetDlgItemText (hDlg, ID_ICON, " ");

              break;

            case LBN_DBLCLK	:
              dwSelection = SendDlgItemMessage (hDlg, 
                                                ID_GROUP_TITLE,
                                                LB_GETCURSEL,
                                                0,
                                                0L
                                               );
              dwSelection++;

              wsprintf (strGrpNum, "Group%ld", dwSelection);
              GetPrivateProfileString ("Groups",
                                       strGrpNum,
                                       "",
                                       strGroupFile,
                                       256,
                                       "progman.ini"
                                      ); 

              OpenGroup ();
              do
              {
                if (bGetGroupMember = GetGroupMembers ())
                  SendDlgItemMessage (hDlg,
                                      ID_GROUP_MEMBERS,
                                      LB_ADDSTRING,
                                      0,
                                      strGroupMember
                                     );
              } while (bGetGroupMember);

              CloseGroup ();
              break;
          }  

          break;

        case ID_GROUP_MEMBERS	:
          switch (HIWORD (lparam))
          {
            case LBN_SELCHANGE	:
              SetDlgItemText (hDlg, ID_PROGRAM, " ");
              SetDlgItemText (hDlg, ID_ICON, " ");

              break;

            case LBN_DBLCLK	:
              dwSelection = SendDlgItemMessage (hDlg, 
                                                ID_GROUP_MEMBERS,
                                                LB_GETCURSEL,
                                                0,
                                                0L
                                               );
              dwSelection++;

              OpenGroup ();
              for (i = 0; 
                   i < dwSelection;
                   i++
                  ) 
                GetGroupMembers ();

              SetDlgItemText (hDlg, ID_PROGRAM, strGroupProgram);
              SetDlgItemText (hDlg, ID_ICON,    strGroupIcon);

              CloseGroup ();
              break;

            default		:
              break;
          }  

          break;

        case ID_EXIT    :
          EndDialog (hDlg, TRUE);
          return (TRUE);

      }

      break;

    }

    return (FALSE);
}

/***************************************
**                                    **
**    OpenGroup                       **
**                                    **
***************************************/
void
OpenGroup (
          )
{
  /* Open group file */
  hFile = OpenFile (strGroupFile, &lpofOpenBuff, OF_READ);

  /* Get displacement of group title */
  _llseek (hFile, 0x16, 0);  
  _lread  (hFile, &wTitleDisplacement, 2);  

  /* Get group title */
  _llseek (hFile, wTitleDisplacement,  0);
  GetString (strGroupTitle);

  /* Set to displacement of first member's displacement */
  wMembersDisplacement = 0x22; 
}

/***************************************
**                                    **
**    CloseGroup                      **
**                                    **
***************************************/
void
CloseGroup (
           )
{
  _lclose (hFile); 			  
}

/***************************************
**                                    **
**    GetGroupMembers                 **
**                                    **
***************************************/
BOOL
GetGroupMembers (
                )
{
  /* Get displacment of member's data */  
  _llseek (hFile, wMembersDisplacement, 0);  
  _lread  (hFile, &wMemberDisplacement, 2);

  /* Check for end of members */
  if (wMemberDisplacement == 0)
    return (FALSE);
  else
    wMembersDisplacement += sizeof (WORD);

  /* Get member's data */
  _llseek (hFile, wMemberDisplacement + 24, 0);
  GetString (strGroupMember);	/* Group Member Title */
  GetString (strGroupProgram);	/* Program Name */
  GetString (strGroupIcon);	/* ICON File Name */

  return (TRUE);

}

/***************************************
**                                    **
**    GetString                       **
**                                    **
***************************************/
void
GetString (LPSTR strString
          )
{
LPSTR lpstrString;
char  strBuffer [2];

  lpstrString = strString;      
  do
  {
    _lread  (hFile, strBuffer, 1);
    lpstrString [0] = strBuffer [0];
    lpstrString++;
  } while (strBuffer [0]);       
}

/***************************************
**                                    **
**    DeleteMemberLB                  **
**                                    **
***************************************/
void
DeleteMembersLB (HANDLE hDlg
                )
{
  while (0 < SendDlgItemMessage (hDlg,
                                 ID_GROUP_MEMBERS,
                                 LB_DELETESTRING,
                                 0,
                                 0L
                                )
        );
} 
                             
                             